import { PluginConfiguration } from '../../config/nx-json';
import { NxPluginV1 } from '../../utils/nx-plugin.deprecated';
import { CreateNodesContext, CreateNodesResult, NxPluginV2 } from './public-api';
export { loadPlugins, loadPlugin } from './worker-api';
export type CreateNodesResultWithContext = CreateNodesResult & {
    file: string;
    pluginName: string;
};
export type NormalizedPlugin = NxPluginV2 & Pick<NxPluginV1, 'processProjectGraph'>;
export type RemotePlugin = Omit<NormalizedPlugin, 'createNodes'> & {
    createNodes: [
        filePattern: string,
        fn: (matchedFiles: string[], context: CreateNodesContext) => Promise<CreateNodesResultWithContext[]>
    ];
};
export declare const nxPluginCache: Map<unknown, [Promise<RemotePlugin>, () => void]>;
/**
 * This loads plugins in isolation in their own worker so that they do not disturb other workers or the main process.
 */
export declare function loadNxPluginsInIsolation(plugins: PluginConfiguration[], root?: string): Promise<[RemotePlugin[], () => void]>;
export declare function loadNxPluginInIsolation(plugin: PluginConfiguration, root?: string): [Promise<RemotePlugin>, () => void];
export declare function getDefaultPlugins(root: string): Promise<string[]>;
