"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMessage = exports.consumeMessage = void 0;
// Takes a message and a map of handlers and calls the appropriate handler
// type safe and requires all handlers to be handled
async function consumeMessage(raw, handlers) {
    const message = typeof raw === 'string' ? JSON.parse(raw) : raw;
    const handler = handlers[message.type];
    if (handler) {
        const response = await handler(message.payload);
        if (response) {
            process.send(createMessage(response));
        }
    }
    else {
        throw new Error(`Unhandled message type: ${message.type}`);
    }
}
exports.consumeMessage = consumeMessage;
function createMessage(message) {
    return JSON.stringify(message);
}
exports.createMessage = createMessage;
