"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const path_1 = require("path");
const psuedo_ipc_1 = require("./psuedo-ipc");
const psuedoIPCPath = process.argv[2];
const forkId = process.argv[3];
const script = (0, path_1.join)(__dirname, '../../bin/run-executor.js');
const childProcess = (0, child_process_1.fork)(script, {
    stdio: ['inherit', 'inherit', 'inherit', 'ipc'],
});
const psuedoIPC = new psuedo_ipc_1.PsuedoIPCClient(psuedoIPCPath);
psuedoIPC.onMessageFromParent(forkId, (message) => {
    childProcess.send(message);
});
psuedoIPC.notifyChildIsReady(forkId);
process.on('message', (message) => {
    psuedoIPC.sendMessageToParent(message);
});
childProcess.on('exit', (code) => {
    psuedoIPC.close();
    process.exit(code);
});
